<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <ClientOnly>
        <Teleport to="#sidebar-nav">
            <div>
                <div class="sidebar-top">
                    <h1>{{ title }}</h1>
                    <div class="button-icon small-btn"><i class="icon-edit"></i></div>
                </div>
                <nav class="secondary-nav" v-if="nav">
                    <ul>
                        <li v-for="item of nav" :key="item.label">
                            <button :class="{ active: item.active }" @click="(event) => item.action(event)">
                                <span class="icon-left">
                                    <i :class="'icon-' + item.icon"></i>
                                </span>
                                <span class="text">
                                    <span v-if="item.preLabel">{{ item.preLabel }}</span>
                                    {{ item.label }}
                                </span>
                                <span class="icon-arrow">
                                    <i class="icon icon-arrow-right"></i>
                                </span>
                            </button>
                        </li>
                    </ul>
                </nav>
                <nav class="update-nav" v-if="navU">
                    <div class="title-updates">{{ titleUpdates }}</div>
                    <ul>
                        <li v-for="item of navU" :key="item.label">
                            <a @click="item.action">
                                <span class="text">
                                    <span class="pre-label" v-if="item.preLabel">{{ item.preLabel }} . </span>
                                    {{ item.label }}
                                </span>
                                <span class="icon-arrow">
                                    <i class="icon icon-arrow-right"></i>
                                </span>
                            </a>
                        </li>
                    </ul>
                </nav>
            </div>
        </Teleport>
    </ClientOnly>
</template>
<script setup lang="ts">
import type NavItemI from '~/interfaces/navItem';
import type NavUpdateI from '~/interfaces/navUpdate';

// receive props (array of NavItem)
const props = defineProps<{
    nav: NavItemI[],
    title: String,
    titleUpdates?: String,
    navU?: NavUpdateI[]
}>()

const backgroundPosition = ref('0 0');

// Method to change background position
const changeBackgroundPosition = (position: string) => {
    backgroundPosition.value = position;
};

</script>